import numpy as np
import os
import sys
import shutil
import time
import urllib
import caffe
from utils import *
import coarse_surgery


data_path = sys.argv[1]
current_fold = int(sys.argv[2])
organ_number = int(sys.argv[3])
low_range = int(sys.argv[4])
high_range = int(sys.argv[5])
slice_threshold = float(sys.argv[6])
organ_ID = int(sys.argv[7])
plane = sys.argv[8]
GPU_ID = int(sys.argv[9])
learning_rate = float(sys.argv[10])
gamma = float(sys.argv[11])
snapshot_path = os.path.join(snapshot_path, 'coarse_' + sys.argv[10])
starting_iterations = int(sys.argv[12])
step = int(sys.argv[13])
max_iterations = [int(s) for s in sys.argv[14].split(',')]
timestamp = sys.argv[15]
snapshot_name = 'FD' + str(current_fold) + ':' + \
    plane + 'C' + '_' + str(organ_ID) + '_' + timestamp
log_file = os.path.join(log_path, snapshot_name + '.txt')
snapshot_directory = os.path.join(snapshot_path, snapshot_name)
if not os.path.exists(snapshot_directory):
    os.makedirs(snapshot_directory)
log_file_ = log_filename(snapshot_directory)
weights = os.path.join(pretrained_model_path, 'fcn8s-heavy-pascal.caffemodel')
if not os.path.isfile(weights):
    print 'Downloading <' + weights + '> from the Internet ...'
    urllib.urlretrieve('http://dl.caffe.berkeleyvision.org/fcn8s-heavy-pascal.caffemodel', weights)

if __name__ == '__main__':
    filename = os.path.join(prototxt_path, 'solver_C' + '.prototxt')
    file = open(filename, 'w')
    prototxt_file = os.path.join(prototxt_path, 'training_C' + '.prototxt')
    if not os.path.isfile(prototxt_file):
        prototxt_file_ = os.path.join('prototxts', 'training_C' + '.prototxt')
        shutil.copyfile(prototxt_file_, prototxt_file)
    file.write('train_net: \"' + prototxt_file + '\"\n')
    file.write('\n' * 1)
    file.write('display: 20\n')
    file.write('average_loss: 20\n')
    file.write('\n' * 1)
    file.write('base_lr: ' + str(learning_rate) + '\n')
    file.write('lr_policy: \"multistep\"\n')
    file.write('gamma: ' + str(gamma) + '\n')
    for t in range(len(max_iterations) - 1):
        file.write('stepvalue: ' + str(max_iterations[t]) + '\n')
    file.write('max_iter: ' + str(max_iterations[-1]) + '\n')
    file.write('\n' * 1)
    file.write('momentum: 0.99\n')
    file.write('\n' * 1)
    file.write('iter_size: 1\n')
    file.write('weight_decay: 0.0005\n')
    file.write('snapshot: ' + str(step) + '\n')
    file.write('snapshot_prefix: \"' + os.path.join(snapshot_directory, 'train') + '\"\n')
    file.write('\n' * 1)
    file.write('test_initialization: false\n')
    file.close()
    sys.path.insert(0, os.path.join(CAFFE_root, 'python'))
    caffe.set_device(GPU_ID)
    caffe.set_mode_gpu()
    solver = caffe.SGDSolver(os.path.join(prototxt_path, 'solver_C' + '.prototxt'))
    if starting_iterations == 0:
        solver.net.copy_from(weights)
    else:
        snapshot_ = os.path.join( \
            snapshot_directory, 'train_iter_' + str(starting_iterations) + '.solverstate')
        solver.restore(snapshot_)
    interp_layers = [k for k in solver.net.params.keys() if 'up' in k]
    coarse_surgery.interp(solver.net, interp_layers)
    solver.step(max_iterations[-1])
    shutil.copyfile(log_file, log_file_)

